/* This routine gives the improved estimator of the magnetization
   squared, which is the sum of the squares of the cluster sizes.
   The size of the largest cluster provides an estimate of the 
   magnetization. A histogram of cluster sizes is also produced.
   The number of clusters is also measured and placed in energy[1].
*/

#include "comext.h"
#include <stdio.h>

SWmeasure()
{
   int i,j,n,size;
   double nssq;

   /* Work out the largest cluster and the sum of squares of the
      cluster sizes */
   nssq = 0.0;
   maxsize = 0;
   for (n=0;n<Nclusters;n++) {
      size = csize[n];
      if (size > maxsize) maxsize = size;
      ns[size-1] ++;
      nssq += (double)size * (double)size;
   }

   energy[1] = volume / (double)Nclusters;
   mag[1] = maxsize / volume;

   magsq[0] = (double)nssq / (volume * volume);
   /*
   magsq[1] = (double)nssq / (volume * volume);
   */
}

